Name: tcb
Version: 0.9.8.7
Release: alt1

Summary: Libraries and tools implementing the %name password shadowing scheme
License: BSD or GPL
Group: System/Base
Url: http://www.openwall.com/tcb/

Source: ftp://ftp.openwall.com/pub/projects/tcb/%name-%version.tar.bz2
Source1: tcb_chkpwd.control

Patch1: %name-0.9.8.7-alt-tcb_convert-try_auth.patch
Patch2: %name-0.9.8.7-alt-openpam.patch

BuildPreReq: libcrypt.so.1(GLIBC_2.2.2)

# Automatically added by buildreq on Tue Oct 07 2003
BuildRequires: libpam-devel

%description
The %name package consists of three components: %pam_name, libnss_%name, and
lib%name.  %pam_name is a PAM module which supersedes pam_unix.  It also
implements the %name password shadowing scheme (see %name(5) for details).
The %name scheme allows many core system utilities (passwd(1) being the
primary example) to operate with little privilege.  libnss_%name is the
accompanying NSS module.  lib%name contains code shared by the PAM and
NSS modules and is also used by programs from the shadow-utils package.

%package -n lib%name
Summary: %name shared library
License: BSD
Group: System/Libraries

%package -n lib%name-devel
Summary: Libraries and header files for building %name-aware applications
License: BSD
Group: Development/C
PreReq: lib%name = %version-%release

%package -n lib%name-devel-static
Summary: Static libraries for building statically linked %name-aware applications
License: BSD
Group: Development/C
Requires: lib%name-devel = %version-%release

%package -n nss_%name
Summary: %name NSS module
License: BSD
Group: System/Libraries
PreReq: lib%name = %version-%release

%set_pam_name pam_%name
%package -n %pam_name
Summary: %name PAM module
License: BSD
Group: System/Base
PreReq: nss_%name = %version-%release, libpam, control
Provides: pam_%name = %version-%release
Provides: %(for n in '' _acct _auth _passwd _session; do echo -n "pam_unix$n.so%_pam_so_suffix "; done)
Obsoletes: pam_%name

%package utils
Summary: %name utilities
License: GPL
Group: System/Base
Provides: /etc/tcb
PreReq: pam_%name = %version-%release, shadow-convert

%description -n lib%name
This package contains code shared by the PAM and NSS modules and is also used
by programs from the shadow-utils package.

%description -n lib%name-devel
This package contains library and header files needed for
building %name-aware applications.

%description -n lib%name-devel-static
This package contains static library needed for
building statically linked %name-aware applications.

%description -n nss_%name
This package contains nss_%name - %name NSS module.

%description -n %pam_name
This package contains %pam_name - %name PAM module which supersedes pam_unix.

%description utils
This package contains utilities to convert to and from the tcb
password shadowing scheme.

%prep
%setup -q
%patch1 -p1
%patch2 -p1

if [ "%_libexecdir" != "/usr/libexec" ]; then
	find -type f -print0 |
		xargs -r0 %__grep -FZl /usr/libexec -- |
		xargs -r0 %__subst -p 's,/usr/libexec,%_libexecdir,g' --
fi

%build
CFLAGS="$RPM_OPT_FLAGS -DENABLE_SETFSUGID" make

%install
%make_install install-non-root install-pam_unix \
	DESTDIR=$RPM_BUILD_ROOT \
	MANDIR=%_mandir \
	#
%__install -pD -m755 %SOURCE1 \
	$RPM_BUILD_ROOT/etc/control.d/facilities/tcb_chkpwd
%__subst -p 's,@libexecdir@,%_libexecdir,g' \
	$RPM_BUILD_ROOT/etc/control.d/facilities/tcb_chkpwd

%__chmod a-x $RPM_BUILD_ROOT/lib{,/security}/*.so*
%add_findprov_lib_path /lib/security

%post -n lib%name -p %post_ldconfig_sys
%postun -n lib%name -p %postun_ldconfig

%post -n nss_%name -p %post_ldconfig_sys
%postun -n nss_%name -p %postun_ldconfig

%pre -n %pam_name
/usr/sbin/groupadd -r -f chkpwd >/dev/null 2>&1 ||:
/usr/sbin/groupadd -r -f shadow >/dev/null 2>&1 ||:

if [ $1 -ge 2 ]; then
	/usr/sbin/control-dump tcb_chkpwd
fi

%post -n %pam_name
if [ $1 -ge 2 ]; then
	/usr/sbin/control-restore tcb_chkpwd
fi

%pre utils
/usr/sbin/groupadd -r -f auth >/dev/null 2>&1 ||:

%post utils
if [ $1 = 1 -a ! -e /etc/tcb ]; then
	/sbin/tcb_convert
fi

%files -n lib%name
/lib/lib%name.so.*
%doc LICENSE

%files -n lib%name-devel
%_libdir/lib*.so
%_includedir/*

%files -n lib%name-devel-static
%_libdir/*.a

%files -n nss_%name
/lib/libnss_*

%files -n %pam_name
/lib/security/pam_*.so*
%attr(710,root,chkpwd) %dir %_libexecdir/chkpwd
%attr(2711,root,shadow) %_libexecdir/chkpwd/tcb_chkpwd
%config /etc/control.d/facilities/tcb_chkpwd
%_man8dir/pam_*

%files utils
/sbin/%{name}_*convert
%_man5dir/%name.*
%_man8dir/tcb_*

%changelog
* Thu Nov 06 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.7-alt1
- Updated to 0.9.8.7:
  * Sun Nov 02 2003 Solar Designer <solar@owl.openwall.com> 0.9.8.7-owl1
  - Build the PAM module with -fPIC.
  - Renamed FAKEROOT to DESTDIR.
- Rediffed patches.

* Thu Oct 30 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.6-alt1
- Updated to 0.9.8.6:
  * Wed Oct 29 2003 Solar Designer <solar@owl.openwall.com> 0.9.8.6-owl1
  - Don't depend on *BSD-style asprintf(3) semantics
    as glibc upstream has rejected that patch.

* Thu Jun 05 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.5-alt2
- Fixed build with OpenPAM.
- Added Linux-PAM/OpenPAM multi-build support.

* Sat Apr 19 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.5-alt1
- Updated to 0.9.8.5:
  * Fri Apr 18 2003 Solar Designer <solar@owl.openwall.com> 0.9.8.5-owl1
  - Use bold face for component names in .SH NAME, but avoid *roff commands
    to not confuse makewhatis and apropos(1).

* Wed Apr 16 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.4-alt1
- In pam_tcb, implemented proper fake salt creation to avoid a timing attack.

* Tue Apr 15 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.3-alt2
- Implemented proper dummy salt creation to avoid a timing attack.

* Sun Jan 12 2003 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.3-alt1
- Updated to 0.9.8.3:
  * Thu Oct 31 2002 Solar Designer <solar@owl.openwall.com>
  - Optimized unix_verify_password() a bit, from Dmitry V. Levin of ALT Linux.
  * Wed Oct 30 2002 Solar Designer <solar@owl.openwall.com>
  - In tcb_convert.8, noted that /etc/shadow backups need to be removed as
    well, with /etc/shadow- as the particular example.
- Added control support for tcb_chkpwd, with three alternatives:
  "tcb" (default), "traditional" (for shadow/nis) and "restricted" (root only).

* Mon Oct 28 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.8.1-alt1
- Updated to 0.9.8.1:
  * Thu Oct 24 2002 Solar Designer <solar@owl.openwall.com>
  - Cleaned up the recent changes.
  * Mon Aug 19 2002 Rafal Wojtczuk <nergal@owl.openwall.com>
  - Merged enhancements which remove 32K users limit.
  - Added ENABLE_SETFSUGID.
  - Pass the username to the helper binary such that it can handle
    non-unique UIDs.
- tcb_chkpwd: optimized unix_verify_password() a bit.

* Mon Sep 02 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.7.4-alt2
- Use subst instead of perl for build.
- Updated devel-static requirements.

* Wed Aug 14 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.7.4-alt1
- 0.9.7.4:
  + Moved the pam_tcb and pam_unix manual pages to section 8.
  + No longer let root enforced password changes (sp_lstchg == 0) take
    precedence over expired accounts (sp_expire).
- Moved static library to devel-static subpackage.
- Fixed libtcb.so symlink (appeared to be broken in previous release).

* Tue May 21 2002 Dmitry V. Levin <ldv@altlinux.org> 0.9.7.1-alt1
- 0.9.7.1: relocated helper:
  /sbin/chkpwd.d/tcb_chkpwd --> %_libexecdir/chkpwd/tcb_chkpwd.

* Thu Feb 07 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.7-alt4
- Refined fsuid patch.

* Wed Feb 06 2002 Dmitry V. Levin <ldv@alt-linux.org> 0.9.7-alt3
- libtcb/tcb_{drop,gain}_priv_r: use fsuid instead of euid.

* Thu Dec 20 2001 Dmitry V. Levin <ldv@alt-linux.org> 0.9.7-alt2
- tcb_convert: try auth group by default.

* Thu Dec 13 2001 Dmitry V. Levin <ldv@alt-linux.org> 0.9.7-alt1
- ALT adaptions, libification.

* Sun Dec 09 2001 Solar Designer <solar@owl.openwall.com>
- Various minor fixes from Dmitry V. Levin of ALT Linux.
- A GNU-style ChangeLog will now be maintained.

* Sun Nov 18 2001 Solar Designer <solar@owl.openwall.com>
- Patches from Nergal to make delays on failure work with the "fork"
option and to not produce a warning when su'ing to pseudo-users from
root.

* Fri Nov 16 2001 Solar Designer <solar@owl.openwall.com>
- Don't include the /sbin/chkpwd.d directory in this package as it's
provided by our pam package.
- Use a trigger on shadow-utils for possibly creating and making use of
group shadow.  This makes no difference on Owl as either the group is
provided by owl-etc (on new installs) or groupadd is already available
when this package is installed, but may be useful on hybrid systems.

* Thu Nov 15 2001 Solar Designer <solar@owl.openwall.com>
- Provide compatibility symlinks and a man page for pam_unix.
- tcb_convert(8) man page fixes from Nergal.
- Moved all of pam_tcb's prompts and messages to support.h and made them
more consistent with those used by pam_passwdqc.
- Improved logging.

* Thu Nov 01 2001 Solar Designer <solar@owl.openwall.com>
- Changed everything all over the place during October. ;-)

* Tue Sep 11 2001 Rafal Wojtczuk <nergal@owl.openwall.com>
- Makefiles and code layout rewrite.
- Added reentrant tcb_*_privs_r() functions, needed for nss.

* Sun Aug 19 2001 Rafal Wojtczuk <nergal@owl.openwall.com>
- version 0.5
- man pages
- nis fixes
- removed ugly _unix_getpwnam(), clean replacement

* Sat Aug 04 2001 Rafal Wojtczuk <nergal@owl.openwall.com>
- 0.4 packaged for Owl.
